aubio 0.4.9

Loading...
Searching...
No Matches
notes.h
Go to the documentation of this file.
1/*
2 Copyright (C) 2003-2014 Paul Brossier <piem@aubio.org>
3
4 This file is part of aubio.
5
6 aubio is free software: you can redistribute it and/or modify
7 it under the terms of the GNU General Public License as published by
8 the Free Software Foundation, either version 3 of the License, or
9 (at your option) any later version.
10
11 aubio is distributed in the hope that it will be useful,
12 but WITHOUT ANY WARRANTY; without even the implied warranty of
13 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14 GNU General Public License for more details.
15
16 You should have received a copy of the GNU General Public License
17 along with aubio. If not, see <http://www.gnu.org/licenses/>.
18
19*/
20
21/** \file
22
23 Note detection object
24
25*/
26
27#ifndef _AUBIO_NOTES_H
28#define _AUBIO_NOTES_H
29
30#ifdef __cplusplus
31 extern "C" {
32#endif
33
34/** notes detection object */
35 typedef struct _aubio_notes_t aubio_notes_t;
36
37/** create notes detection object
38
39 \param method notes detection type as specified in specdesc.h
40 \param buf_size buffer size for phase vocoder
41 \param hop_size hop size for phase vocoder
42 \param samplerate sampling rate of the input signal
43
44 \return newly created ::aubio_notes_t
45
46*/
47 aubio_notes_t * new_aubio_notes (const char_t * method,
48 uint_t buf_size, uint_t hop_size, uint_t samplerate);
49
50/** delete notes detection object
51
52 \param o notes detection object to delete
53
54*/
55 void del_aubio_notes(aubio_notes_t * o);
56
57/** execute note detection on an input signal frame
58
59 \param o note detection object as returned by new_aubio_notes()
60 \param input input signal of size [hop_size]
61 \param output output notes, fvec of length 3
62
63 The notes output is a vector of length 3 containing:
64 - 0. the midi note value, or 0 if no note was found
65 - 1. the note velocity
66 - 2. the midi note to turn off
67
68*/
69 void aubio_notes_do (aubio_notes_t *o, const fvec_t * input, fvec_t * output);
70
71/** set notes detection silence threshold
72
73 \param o notes detection object as returned by new_aubio_notes()
74 \param silence new silence detection threshold
75
76 \return 0 on success, non-zero otherwise
77
78*/
79 uint_t aubio_notes_set_silence(aubio_notes_t * o, smpl_t silence);
80
81/** get notes detection silence threshold
82
83 \param o notes detection object as returned by new_aubio_notes()
84
85 \return current silence threshold
86
87*/
88 smpl_t aubio_notes_get_silence(const aubio_notes_t * o);
89
90/** get notes detection minimum inter-onset interval, in millisecond
91
92 \param o notes detection object as returned by new_aubio_notes()
93
94 \return current minimum inter onset interval
95
96 */
97 smpl_t aubio_notes_get_minioi_ms(const aubio_notes_t *o);
98
99/** set notes detection minimum inter-onset interval, in millisecond
100
101 \param o notes detection object as returned by new_aubio_notes()
102 \param minioi_ms new inter-onset interval
103
104 \return 0 on success, non-zero otherwise
105
106*/
107 uint_t aubio_notes_set_minioi_ms (aubio_notes_t *o, smpl_t minioi_ms);
108
109/** get notes object release drop level, in dB
110
111 \param o notes detection object as returned by new_aubio_notes()
112
113 \return current release drop level, in dB
114
115 */
116 smpl_t aubio_notes_get_release_drop (const aubio_notes_t *o);
117
118/** set note release drop level, in dB
119
120 This function sets the release_drop_level parameter, in dB. When a new note
121 is found, the current level in dB is measured. If the measured level drops
122 under that initial level - release_drop_level, then a note-off will be
123 emitted.
124
125 Defaults to `10`, in dB.
126
127 \note This parameter was added in version `0.4.8`. Results obtained with
128 earlier versions can be reproduced by setting this value to `100`, so that
129 note-off will not be played until the next note.
130
131 \param o notes detection object as returned by new_aubio_notes()
132 \param release_drop new release drop level, in dB
133
134 \return 0 on success, non-zero otherwise
135
136*/
137 uint_t aubio_notes_set_release_drop (aubio_notes_t *o, smpl_t release_drop);
138
139#ifdef __cplusplus
140}
141#endif
142
143#endif /* _AUBIO_NOTES_H */
aubio_notes_set_minioi_ms
uint_t aubio_notes_set_minioi_ms(aubio_notes_t *o, smpl_t minioi_ms)
set notes detection minimum inter-onset interval, in millisecond
aubio_notes_get_release_drop
smpl_t aubio_notes_get_release_drop(const aubio_notes_t *o)
get notes object release drop level, in dB
aubio_notes_get_silence
smpl_t aubio_notes_get_silence(const aubio_notes_t *o)
get notes detection silence threshold
aubio_notes_do
void aubio_notes_do(aubio_notes_t *o, const fvec_t *input, fvec_t *output)
execute note detection on an input signal frame
aubio_notes_set_release_drop
uint_t aubio_notes_set_release_drop(aubio_notes_t *o, smpl_t release_drop)
set note release drop level, in dB
del_aubio_notes
void del_aubio_notes(aubio_notes_t *o)
delete notes detection object
aubio_notes_get_minioi_ms
smpl_t aubio_notes_get_minioi_ms(const aubio_notes_t *o)
get notes detection minimum inter-onset interval, in millisecond
new_aubio_notes
aubio_notes_t * new_aubio_notes(const char_t *method, uint_t buf_size, uint_t hop_size, uint_t samplerate)
create notes detection object
aubio_notes_set_silence
uint_t aubio_notes_set_silence(aubio_notes_t *o, smpl_t silence)
set notes detection silence threshold
aubio_notes_t
struct _aubio_notes_t aubio_notes_t
notes detection object
Definition: notes.h:35
fvec_t
Buffer for real data.
Definition: fvec.h:67
uint_t
unsigned int uint_t
unsigned integer
Definition: types.h:60
char_t
char char_t
character
Definition: types.h:64
smpl_t
float smpl_t
short sample format (32 or 64 bits)
Definition: types.h:41